package assignment1.gallery;

import java.util.GregorianCalendar;
import java.util.LinkedList;

import assignment1.exhibit.Exhibit;
import assignment1.exhibit.sculptures.Sculpture;

public class Gallery {

	private Exhibit[] exhibits;
	
	public Gallery() {
		exhibits = new Exhibit[100];
	}
	
	private int firstFreeIndex(){
		for (int i = 0; i < exhibits.length; i++) {
			if ( exhibits[i] == null ) return i;
		}
		return -1;
	}
	
	public void addNewExhibit(Exhibit exhibit) {
		int firstFreeSpace = firstFreeIndex();
		if ( firstFreeSpace < 0 || exhibit == null ) {
			System.out.println("Error!");
		} else {
			exhibits[firstFreeSpace] = exhibit;
			exhibits[firstFreeSpace].setDateReceived(new GregorianCalendar());
		}
	}
	
	public void enableDiscount(double discount) {
		int previousYear = 
				(new GregorianCalendar()).get(GregorianCalendar.YEAR) - 1;
		for (int i = 0; i < exhibits.length; i++) {
			if ( exhibits[i] != null &&
					exhibits[i].getDateReceived().get(GregorianCalendar.YEAR) == previousYear) {
			
				double price = exhibits[i].getPrice();
				exhibits[i].setPrice( price * (100-discount)/100);
				
			}
		}
		
	}
	
	public Sculpture[] mostExpensive() {
		Sculpture[] sculptures = new Sculpture[2];
		
		LinkedList<Sculpture> bronzeSculptures = new LinkedList<Sculpture>(); 
		
		for (int i = 0; i < exhibits.length; i++) {
			if ( exhibits[i] != null && exhibits[i] instanceof Sculpture ) {
				Sculpture s = (Sculpture)exhibits[i];
				if ( s.getMaterial().equals("bronze") ) {
					if ( bronzeSculptures.isEmpty() )
						bronzeSculptures.addFirst(s);
					else {
						boolean added = false;
						for (int j = 0; j < bronzeSculptures.size(); j++) {
							if ( bronzeSculptures.get(j).getPrice() < s.getPrice() ) {
								bronzeSculptures.add(j, s);
								added = true;
								break;
							}
						}
						if ( !added )
							bronzeSculptures.addLast(s);
					}
				}
			}
		}
		
		sculptures[0] = bronzeSculptures.getFirst();
		sculptures[1] = bronzeSculptures.get(1);
			
		return sculptures;
	}
	
}








