package assignment2.cars;

import java.util.GregorianCalendar;
import java.util.LinkedList;

import assignment2.cars.tires.Tire;
import assignment2.cars.tires.searchengine.TireSearchEngine;

public class CarRepairShop implements TireSearchEngine {

	private LinkedList<Tire> tires = new LinkedList<Tire>();
	
	@Override
	public void displayOffer(int width, int height, int diameter, boolean isWinter) {
		
		String dimensions = width + "/" + height + "/" + diameter;
		for (Tire tire : tires) {
			if ( tire.getDimensions().equals(dimensions) && 
					tire.isWinterTire() == isWinter )
				System.out.println( tire );
		}

	}

	@Override
	public void addTire(Tire tire) {
		if ( tire != null && tire.getDateMade().before(new GregorianCalendar()))
			tires.addFirst(tire);
		else System.out.println("Error when adding a tire");

	}
	
	public void reverseElements() {
		
		LinkedList<Tire> reversed = new LinkedList<Tire>();
		for (int i = tires.size()-1; i >= 0; i--) {
			reversed.add(tires.get(i));
		}
		
		tires = reversed;
	}

}
