package cars;

import java.util.GregorianCalendar;
import java.util.LinkedList;

import cars.tires.Tire;
import cars.tires.searchengine.TireSearchEngine;

public class CarRepairShop implements TireSearchEngine {

	LinkedList<Tire> tires = new LinkedList<Tire>();
	
	@Override
	public void displayOffer(int width, int height, int diameter, boolean isWinter) {
		String dimensions = width + "/" + height + "/" + diameter;
		for (int i = 0; i < tires.size(); i++) {
			if ( tires.get(i).getDimensions().equals(dimensions) &&
					tires.get(i).isWinterTire() == isWinter)
				System.out.println( tires.get(i) );
		}

	}

	@Override
	public void addTire(Tire tire) {
		if ( tire != null && tire.getDateMade().before(new GregorianCalendar()))
			tires.addFirst(tire);
		else System.out.println("Error!");

	}
	
	public void reversetheOrder() {
		LinkedList<Tire> reversed = new LinkedList<Tire>();
		for (int i = tires.size()-1; i >= 0; i--) {
			reversed.add( tires.get(i));
		}
		tires = reversed;
	}

}
