package gallery;

import java.util.GregorianCalendar;
import java.util.LinkedList;

import exhibits.Exhibit;
import exhibits.sculptures.Sculpture;

public class Gallery {

	private Exhibit[] exhibits;
	
	public Gallery() {
		exhibits = new Exhibit[100];
	}
	
	private int firstFreeIndex() {
		for (int i = 0; i < exhibits.length; i++) {
			if ( exhibits[i] == null ) return i;
		}
		return -1;
	}
	
	public void addNewExhibit(Exhibit e) {
		int indexFree = firstFreeIndex();
		if ( indexFree >= 0 && e != null ) {
			exhibits[indexFree] = e;
			exhibits[indexFree].setDateReceived(new GregorianCalendar());
		} else 
			System.out.println("Error!");
	}
	
	public void enableDiscount(double discount) {
		int targetYear = 
				(new GregorianCalendar()).get(GregorianCalendar.YEAR) - 1;
		for (int i = 0; i < exhibits.length; i++) {
			if ( exhibits[i] != null &&
					exhibits[i].getDateReceived().get(GregorianCalendar.YEAR) == targetYear){
				double price = exhibits[i].getPrice();
				exhibits[i].setPrice(price * (100 - discount)/100);
			}
		}
	}	
	
	public Sculpture[] mostExpensiveMadeOfBronze() {
		Sculpture[] mostExpensive = new Sculpture[2];
		
		LinkedList<Sculpture> bronzeSculptures = new LinkedList<Sculpture>();
		for (int i = 0; i < exhibits.length; i++) {
			if ( exhibits[i] != null && exhibits[i] instanceof Sculpture) {
				Sculpture s = (Sculpture)exhibits[i];
				if ( s.getMaterial().equals("bronze" ) == false) continue;
				
				if (bronzeSculptures.isEmpty())
					bronzeSculptures.addFirst(s);
				else {
					boolean added = false;
					for (int j = 0; j < bronzeSculptures.size(); j++) {
						if (s.getPrice() > bronzeSculptures.get(j).getPrice() ) {
							bronzeSculptures.add(j, s);
							added = true;
							break;
						}
					}
					if ( added == false )
						bronzeSculptures.addLast(s);
				}
			}
		}
		
		mostExpensive[0] = bronzeSculptures.getFirst();
		mostExpensive[1] = bronzeSculptures.get(1);
		
		return mostExpensive;
	}
	
	
	public Sculpture findMaximum(Sculpture p) {
		Sculpture maximum = new Sculpture();
		
		for (int i = 0; i < exhibits.length; i++) {
			if(exhibits[i] instanceof Sculpture) {
				Sculpture s = (Sculpture) exhibits[i];
				if(s.getMaterial().equals("bronze") == true) {
					if(s.getPrice() > maximum.getPrice()) {
						if ( p == null )
							maximum = s;
						else if (s.getPrice() < p.getPrice()) {
							maximum = s;
						}
					}
						
				}
			}
		}
		return maximum;
		
	}
	public Sculpture [] mostExpensive() {
		Sculpture [] mostExpensive = new Sculpture[2];
		mostExpensive[0] = findMaximum(null);
		mostExpensive[1] = findMaximum(mostExpensive[0]);
		return mostExpensive;
	}
}









